#ifndef CLEANERREADER_H_UNIVERSITY_OF_OREGON_NIC
#define CLEANERREADER_H_UNIVERSITY_OF_OREGON_NIC

#include "reader.h"
#include <iostream>
#include <cstring>

#include "nic_matrix.h"

#include "MPIWrapper.h"

#include "PartitionedDataset.h"

#ifdef __DISTRIBUTED // -----------------------

#include "d_ascii_matrix.h"
#include "d_ascii_T_matrix.h"
#include "d_binary_T_matrix.h"

#else

#ifdef __OPENMP_ //#############################################################
                                                                           // ..
#include "omp.h"                                                           // ..
                                                                           // ..
#endif //----------------------------------------------------------------------

#include "binary_matrix.h"
#include "binary_T_matrix.h"
#include "ascii_matrix.h"
#include "ascii_T_matrix.h"

#endif
// for writing out matrix
#include "ascii_mat_writer.h"

bool read_validate(char * file_name);


class CleanerReader : public Reader 
{
protected:
    // these are for distributed systems
    char * data_src;
    int obs, ch;
    char orient;

public:
    enum PROCESS_TYPE {NONE, FASTICA, INFOMAX, PCA};
    PROCESS_TYPE process;
    char type;

    /* DATA REQUIRED BY CALLING CLASSES *****************************************/
    int                  n_procs; // this is not useful for the MPI version       
    //----------------------------------------------------------------------------

    CleanerReader( istream& inStream );

  ~CleanerReader();

  void validate_read(); 
  void get_value();

  nic_matrix* load_matrix(int rank, int n_cpus);

private:
  void get_process_type(int current_phrase);
};

#endif
// CLEANERREADER_H_UNIVERSITY_OF_OREGON_NIC
