#ifndef CONTRASTFUNCTIONS_H_UNIVERSITY_OF_OREGON_NIC
#define CONTRASTFUNCTIONS_H_UNIVERSITY_OF_OREGON_NIC

#include "nic_matrix.h"
#include "nic_vector.h"

namespace ContrastFunctions
{

    // the contrast function pointer type
    // note, since these are static no class scoping is needed
    typedef void (*ContrastFunction) (nic_matrix*, nic_vector*, nic_vector* );

    enum Type
    {
        HYPERBOLIC_TAN,
        CUBIC,
        GAUSSIAN
    };

    void hyperbolicTan( nic_matrix*, nic_vector*, nic_vector* );
    void cubic( nic_matrix*, nic_vector*, nic_vector* );
    void gaussian( nic_matrix*, nic_vector*, nic_vector* );

    ContrastFunction getContrastFunction( Type type );
}

#endif
// CONTRASTFUNCTIONS_H_UNIVERSITY_OF_OREGON_NIC
