#ifndef INFOMAXREADER_H_UNIVERSITY_OF_OREGON_NIC
#define INFOMAXREADER_H_UNIVERSITY_OF_OREGON_NIC

#include "reader.h"

#include "nic_matrix.h"

#include "binary_matrix.h"
#include "binary_T_matrix.h"
#include "ascii_matrix.h"
#include "ascii_T_matrix.h"

bool read_validate(char * file_name);

class InfomaxReader : public Reader 
{
public:

    double  tolerance;
    int     max_iterations;
    int     max_retries;
    char    initialization_type;
    char  * user_source;
    char    user_type;
    char    user_orient;
    int     nn_block_size;
    double  nn_learning_rate;
    double  nn_annealing_degree;
    double  nn_annealing_scale;
    char    nn_random_learning;
    double  nn_max_weight;
    double  nn_max_divergence;
    double  nn_weight_restart_factor;
    double  nn_divergence_factor;
    double  nn_min_learning_rate;

    InfomaxReader( std::istream& inStream );

    void get_value();

    void load_user_init(nic_matrix* init_mat);

 private:
 protected:

};

#endif
// INFOMAXREADER_H_UNIVERSITY_OF_OREGON_NIC
