#ifndef INFOMAXSETTINGS_H_UNIVERSITY_OF_OREGON_NIC
#define INFOMAXSETTINGS_H_UNIVERSITY_OF_OREGON_NIC

#include <string>
#include "ContrastFunctions.h"
#include "MatrixReader.h"

struct InfomaxSettings
{
    enum InitializationType
    {
        IDENTITY,
        RANDOM,
        USER_SPECIFIED
    };

    double convergenceTolerance;
    int maximumIterations;
    int maximumRetries;
    InitializationType initializationType;
    std::string userInitializationFile;
    MatrixReader::Format userInitializationFormat;

    int nnBlockSize;
    double nnLearningRate;
    double nnAnnealingDegree;
    double nnAnnealingScale;
    bool nnRandomLearning;
    double nnMaxWeight;
    double nnDivergence;
    double nnMaxDivergence;
    double nnWeightRestartFactor;
    double nnDivergenceFactor;
    double nnMinLearningRate;
};

#endif
// INFOMAXSETTINGS_H_UNIVERSITY_OF_OREGON_NIC
