#ifndef MATRIXOPERATIONS_H_UNIVERSITY_OF_OREGON_NIC
#define MATRIXOPERATIONS_H_UNIVERSITY_OF_OREGON_NIC

#include "nic_matrix.h"
#include "nic_vector.h"
#include "LAPACKWrapper.h"


extern "C" int dgemm_(char *, char *, int *, int *, int *, double *,
    double *, int *, double *, int *, double *, double *, int *);

extern "C" int dgemv_( char*, int*, int*, double*, double*, int*,
    double*, int*, double*, double*, int* );

void transposeSquare( nic_matrix& matrix );

void parallelDgemm( 
    char* tA, char* tB,
    int* m, int* n, int* k,
    double* alpha, double* A, int* ldA,
    double* B, int* ldB,
    double* beta, double* C, int* ldC );

void parallelDgemv(
    char* tA,
    int* m, int* n,
    double* alpha, double* A, int* ldA,
    double* x, int* incx,
    double* beta, double* y, int* incy );

// compute C = op1(A)*op2(B)
void multiply(
    nic_matrix& A,
    nic_matrix& B,
    nic_matrix& C,
    bool transposeA = false,
    bool transposeB = false );


// compute c = op(A) * b
void multiply(
    nic_matrix& A,
    nic_vector& b,
    nic_vector& c,
    bool transposeA = false );

// compute B = op(A) * B
// B is overwritten, can not be transposed
void multiply(
    nic_matrix& A,
    nic_matrix& B,
    bool transposeA = false );

void multiplyAdiag(
    nic_vector& A,
    nic_matrix& B,
    nic_matrix& C,
    bool transposeB = false );

void multiplySimple(
    nic_matrix& A,
    nic_matrix& B,
    nic_matrix& C,
    bool transposeA = false,
    bool transposeB = false );

bool invert( nic_matrix& A, nic_matrix& Ainv );

#endif
// MATRIXOPERATIONS_H_UNIVERSITY_OF_OREGON_NIC
