/*******************************************************************************
Kevin Glass                                                                     
NeuroInformatics Center, University of Oregon                                   
Nov. 23, 2004                                                                   
 ******************************************************************************/


/*------------------------------------------------------------------------------
class Output -- Base class for all output processes.                            
                                                                                
------------------------------------------------------------------------------*/


#ifndef __OUTPUT_H
#define __OUTPUT_H

#include <iostream>


class Preprocessor;
class Processor;

class Output {
 protected:
 public:
  Output() {};
  virtual ~Output() {}

  virtual void run(int rank) = 0;
  virtual void validate_load() = 0;
  virtual void setup(Preprocessor * preprocessor, Processor * processor) = 0;
};

#endif
