#ifndef __PARTITIONED_DATASET_H
#define __PARTITIONED_DATASET_H

#include <cstring>

#include "nic_vector.h"
#include "nic_matrix.h"

class PartitionedDataset
{
public:
    typedef char            FileType;
    enum
    {
        c_fileType_binaryBigEndian = 'B',
        c_fileType_binaryLittleEndian = 'L',
        c_fileType_binaryNativeEndian = 'P'
    };
    
    typedef char            FileOrientation;
    enum
    {
        c_fileOrientationColumnMajor = 'C',
        c_fileOrientationRowMajor = 'O'
    };
    
    
    void loadFile(
        int                 rank,
        const std::string&  dataSrc,
        nic_matrix* data,
        int                 ch,
        int                 columns,
        int                 rem,
        int                 obs,
        int                 n_cpus,
        FileType            fileType,
        FileOrientation     fileOrientation );
        
    void storeFile( int rank, nic_matrix* mat, const std::string& m_whitenedFilename , int n_cpus=1, int* shuffle=NULL, int* invVector=NULL) ;

    static void distributeMatrix( nic_matrix* data );
    static void broadcastMatrix( nic_matrix* data );
    static void gatherMatrix( nic_matrix* data );
};

#endif


