#ifndef PREPROCESSREADER_H_UNIVERSITY_OF_OREGON_NIC
#define PREPROCESSREADER_H_UNIVERSITY_OF_OREGON_NIC

#include <iostream>
#include <cstring>
#include "reader.h"

#include "nic_matrix.h"

#include "binary_matrix.h"
#include "ascii_matrix.h"
#include "ascii_T_matrix.h"
#include "binary_T_matrix.h"

bool read_validate(char * file_name);

class PreprocessReader : public Reader {
 public:
  enum PREPROCESS_TYPE {WHITEN, VALIDATE_WHITENED, STORE_WHITENED};

  bool                    load_sphere;
  char                    sphr_file_type;
  char                    sphr_orientation;
  char                  * sphr_file_name;
  int                     n_processes;
  PREPROCESS_TYPE       * preprocess_flow;
  int                     flow_number;
  nic_matrix* sph_matrix;
  std::string               m_whitenedFilename;

  int                     rank;
  int                     n_cpus;


  PreprocessReader( istream& inStream );

  ~PreprocessReader()
  {
//      if ( preprocess_flow ) delete[] preprocess_flow;
     if ( sphr_file_name ) delete [] sphr_file_name;
  }

  void get_value();
  
  void load_sphering_matrix(int n);

 protected:
  void get_preprocess_flow(int current_phrase);

};

#endif
// PREPROCESSREADER_H_UNIVERSITY_OF_OREGON_NIC
