#ifndef PREPROCESSOR_H_UNIVERSITY_OF_OREGON_NIC
#define PREPROCESSOR_H_UNIVERSITY_OF_OREGON_NIC

#include "nic_vector.h"
#include "nic_matrix.h"
#include "PreprocessReader.h"
#include "PartitionedDataset.h"

extern void whiten_data(nic_matrix*, nic_vector*,
	    nic_matrix*, nic_matrix*,
	    nic_matrix*, nic_vector*,
	    bool compute_sph, bool useInfomaxSphering);

extern void validate_whitening(nic_matrix*, nic_vector*,
			       nic_matrix*, nic_matrix*,
			       nic_matrix*, nic_vector*,
			       const std::string& outputDir );



class Preprocessor 
{
protected:

public:
    PreprocessReader::PREPROCESS_TYPE * preprocess_flow;
    int                  n_processes;
    bool                 monitor_conv;
    bool                 m_useInfomaxSphering;

    nic_matrix* data;    // passed to the constructor
    nic_vector* avg;     // allocated in run()
    nic_matrix* cov;     // allocated in run()
    nic_matrix* q;       // allocated in run()
    nic_vector* lambda;  // allocated in run()
    nic_matrix* sph;     // allocated in run() or retrieved from reader
    int n_rows, n_columns, size;
    int rank, n_cpus;

    std::string         m_whitenedFilename;

    Preprocessor(nic_matrix* d, PreprocessReader * reader, int r,
	       int c, bool useInfomaxSphering );
    ~Preprocessor();

    void run();

    void validate_load();
};

#endif
// PREPROCESSOR_H_UNIVERSITY_OF_OREGON_NIC
