#ifndef __PROCESS_READER_H
#define __PROCESS_READER_H

#include "ICAOutput.h"
#include "Preprocessor.h"
#include "Processor.h"
#include "nic_matrix.h"

#include "CleanerReader.h"
#include "FastICAReader.h"
#include "InfomaxReader.h"
#include "ICAOutputReader.h"
#include "PreprocessReader.h"

#include "FastICA.h"
#include "Infomax.h"

#include <string>
#include <iostream>
#include <cstdlib>

#ifdef USE_TAU_PROFILING
#include "TAU.h"
#endif


class ProcessReader
{
protected:
    int                   rank;
    int                   n_cpus;
public:
    Preprocessor        * preprocessor;
    Processor           * process;
    ICAOutput           * output;
    bool                  monitor_conv;
    bool                  validate;
    nic_matrix* data;

    ProcessReader( int r, int np, std::istream& formStream );
    ~ProcessReader();
    void validate_load();
};

#endif
