#ifndef ASCII_T_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
#define ASCII_T_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC

#include "ascii_T_matrix.h"

ASCIIMatrixT::ASCIIMatrixT( nic_matrix* mat, char* file_name, bool store )
{
    data    = mat->data;
    rows    = mat->rows;
    columns = mat->columns;
    size    = mat->size;

    std::cout << "Reading file " << file_name << std::endl;
    read(file_name);

    // store in binary file
    if (store) 
    {
      store_data(file_name);
    }
}

void ASCIIMatrixT::read(char* file_name) 
{
    double* d = NULL;
    d = data;

    // read ascii version
    FILE * fh = fopen (file_name, "r");

    for (int i = 0; i < size; i++) 
    {
      fscanf(fh, "%lf", d);
      d++;
    }
    fclose(fh);
}

void ASCIIMatrixT::store_data(char * file_name) 
{
  int n = strlen(file_name);
  char * f_name = mangle_name(file_name, NULL, "bcoT_", NULL);

  FILE * fh = fopen(f_name, "wb");
  fwrite(data, size, sizeof(double), fh);
  fclose(fh);
}

#endif
// ASCII_T_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
