#ifndef ASCII_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC
#define ASCII_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC

#include "ascii_mat_writer.h"

ASCIIMatrixWriter::ASCIIMatrixWriter(
    nic_matrix* mat, const char * file_name, 
    char space, int* shuffle, int* invVector, int rowcolshuffle) 
{
    bool shuffleEqNull = false;
    if ( shuffle == 0 ) shuffleEqNull = true;
    double * data    = mat->data;
    double * d       = 0;
    double * dtemp = 0;
    int rows    = mat->rows;
    int columns = mat->columns;

    FILE * fh = fopen(file_name, "w");

    // write ASCII values rows-by-columns

    for (int i = 0; i < rows; i++) 
    { 
        if(shuffle!=0 && rowcolshuffle==0) dtemp = data + shuffle[i];
        else dtemp = data + i;
      
        for (int j = 0; j < columns; j++) 
        {


	        if(shuffle!=0 && rowcolshuffle==1) 
	        {
	            d = dtemp + rows*shuffle[j];
	        }
	        else
	        {
	            d = dtemp + j*rows;
	        }
	      
	        int k;
	        if(rowcolshuffle == 0) k=i;
	        else k=j;
	        if(invVector != 0 && shuffle == 0 ) 
            {
                fprintf(fh, "%lf%c", (*d)*invVector[k], space);  
            }
            else
            {
                if(invVector != 0 && !shuffleEqNull ) 
                {
                    fprintf(fh, "%lf%c", (*d)*invVector[shuffle[k]], space);  
                }
                else
		        {
                	fprintf(fh, "%lf%c", *d, space);  
		        }
            } 
	   
        }
        fprintf(fh, "\n");
    }

    fclose(fh);
}


#endif
// ASCII_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC
