#ifndef ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
#define ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC

#include "ascii_matrix.h"

ASCIIMatrix::ASCIIMatrix( nic_matrix* mat, char * file_name, bool store ) 
{
    data = mat->data;
    rows = mat->rows;
    columns = mat->columns;
    size = mat->size;

    read(file_name);

    // store in binary file
    if (store) 
    {
        store_data(file_name);
    }
}

void ASCIIMatrix::read(char * file_name) 
{
    double * d = NULL;

    // read ascii version, file_name validated in CleanerReader
    FILE * fh = fopen (file_name, "r");

    for (int i = 0; i < rows; i++) 
    {
        d = data + i;
        for (int j = 0; j < columns; j++) 
        {
            fscanf(fh, "%lf", d);
            d += rows;
        }
    }
    fclose(fh);
}

void ASCIIMatrix::store_data(char * file_name) 
{
    int n = strlen(file_name);
    char * f_name = mangle_name(file_name, NULL, "bco_", NULL);

    FILE * fh = fopen(f_name, "wb");
    fwrite(data, size, sizeof(double), fh);
    fclose(fh);
}

#endif
// ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
