#ifndef AVERAGE__UNIVERSITY_OF_OREGON_NIC
#define AVERAGE__UNIVERSITY_OF_OREGON_NIC

#include "average.h"

void average(nic_matrix* d, nic_vector* a) 
{
    double* data = d->data;
    double* avg = a->data;

    double* d_ptr = NULL;
    double* a_ptr = NULL;

    int ch = d->rows;
    int obs = d->columns;
    int size = d->size;
//    double n = 1/((double)size); // I don't think that this is right
                                 // we want to average each row individually

    // multiply is faster than divide, so divide once and multiply many times
    // premature optimization...
    double n = 1/((double)(obs));

// Removed distributed until this is tested. Also, need to reconcile
// how shared code between OpenMP algorithms and and MPI algorithms
// is taken care of.
/*
    #ifdef __DISTRIBUTED
    nic_vector avg_temp(ch);
    #endif

*/
    for (int i = 0; i < obs; i++) 
    {
        d_ptr = data + i * ch;
        a_ptr = avg;

        for (int j = 0; j < ch; j++) 
        {
            *a_ptr += (d_ptr[j] * n );
            ++a_ptr;
        }
    }

/*
    #ifdef __DISTRIBUTED
    // In the distributed implementation, each processor has a partial
    // set of the sums, they need to be accumulated across all 
    // processors

    MPI_Allreduce(a->data, avg_temp.data, ch, MPI_DOUBLE, MPI_SUM, 
        MPI_COMM_WORLD);
    a->swap_vectors(&avg_temp);

    avg = a->data;
    // at this point, all processors have the total sum and sums of sqs
    #endif

*/
    for (int i = 0; i < ch; i++) 
    {
//        avg[i] *= n;
    }
}

#endif
// AVERAGE__UNIVERSITY_OF_OREGON_NIC
