#ifndef BINARY_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC
#define BINARY_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC

#include "binary_mat_writer.h"

void 
BinaryMatrixWriter::swapDouble( double& val )
{
   double* dptr = &val;
    
   unsigned char*   cptr = (unsigned char*) dptr;
   unsigned char    tmp;
   
   tmp = cptr[ 0 ];
   cptr[ 0 ] = cptr[ 7 ];
   cptr[ 7 ] = tmp;
   
   tmp = cptr[ 1 ];
   cptr[ 1 ] = cptr[ 6 ];
   cptr[ 6 ] = tmp;
   
   tmp = cptr[ 2 ];
   cptr[ 2 ] = cptr[ 5 ];
   cptr[ 5 ] =tmp;
   
   tmp = cptr[ 3 ];
   cptr[ 3 ] = cptr[ 4 ];
   cptr[ 4 ] = tmp;
}


BinaryMatrixWriter::BinaryMatrixWriter(
    nic_matrix* mat, const char * file_name, 
    int* shuffle, int* invVector, int rowcolshuffle, 
    FileType fileType ) 
{
    #if BIG_ENDIAN == BYTE_ORDER
    FileType            nativeType = 'B';
    bool                swap = ( fileType == 'L' );
    #elif LITTLE_ENDIAN == BYTE_ORDER
    FileType            nativeType = 'L';
    bool                swap = ( fileType == 'B' );
    #endif
  
    double* data    = mat->data;
    int rows         = mat->rows;
    int columns      = mat->columns;
    double *d = NULL;
    double *dtemp = NULL;
    
    FILE * fh = fopen(file_name, "wb");

    // Write binary values in column-major representation,
    // the data is output as a column x rows matrix. 

    //fwrite(data, sizeof(T), columns*rows, fh);
    //++data;
    
    for (int i = 0; i < columns; i++) 
    { 
        if(shuffle!=NULL && rowcolshuffle==1) 
        {
            dtemp = data + rows*shuffle[i];
        }
        else dtemp = data + rows*i;
      
        for (int j = 0; j < rows; j++) 
        {
            int k;
            if(rowcolshuffle == 0) k=j;
            else k=i;

            if(shuffle!=NULL && rowcolshuffle==0) 
            {
                d = dtemp + shuffle[j];
            }
            else
            { 
                d = dtemp + j;
            }

            if(invVector!=NULL && shuffle!=NULL) 
            {
                *d = (*d)*invVector[shuffle[k]];
            }
            else 
            {
                if(invVector!=NULL && shuffle==NULL)
                {
                    *d = (*d)*invVector[k];
                }
            }

            double      swapMe = *d;
            
            if ( swap )
            {
                swapDouble( swapMe );
            }
            
            fwrite( &swapMe, sizeof(double), 1, fh);
        }
    }
    fclose(fh);
}

#endif
// BINARY_MAT_WRITER_CPP_UNIVERSITY_OF_OREGON_NIC
