#ifndef D_ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
#define D_ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC

#include "d_ascii_matrix.h"

DASCIIMatrix::DASCIIMatrix(nic_matrix* mat, char * file_name, 
    int offset, int obs) 
:   ASCIIMatrix(mat, file_name, true)
{

    int n_cpus = mat->n_cpus;

    inherited::size = obs * inherited::rows;  // rows is declared in superclass
    double* dest= new double[mat->size];

    // possibly unsafe!
    if ( mat->data != 0 ) delete[] mat->data;
    mat->data = dest;
    mat->columns = obs;
    mat->size = inherited::size;

    memcpy(dest, inherited::data + offset * inherited::rows, sizeof(double) * obs);
    for (int i = 1; i < n_cpus; i++) 
    {
#ifdef __DISTRIBUTED
        MPI_Send( inherited::data + i * offset * inherited::rows, 
            inherited::size, MPI_DOUBLE, i, 1, MPI_COMM_WORLD);
#endif
      // package and distribute blocks of data
    }
    delete inherited::data;

};

#endif
// D_ASCII_MATRIX_CPP_UNIVERSITY_OF_OREGON_NIC
