#ifndef __DISTR_BINARY_T_MATRIX_H
#define __DISTR_BINARY_T_MATRIX_H

#include "MPIWrapper.h"

#include "nic_matrix.h"
#include "binary_T_matrix.h"

class DBinaryMatrixT : BinaryMatrixT
{
	typedef BinaryMatrixT inherited;
	
protected:

 public:

    DBinaryMatrixT( nic_matrix* mat, char* file_name, int offset, int obs) :
        BinaryMatrixT( mat, file_name, false, offset )
{

    int n_cpus = mat->n_cpus;

    inherited::size = obs * inherited::rows;  // rows and columns are declared in superclass
    double* dest= new double[mat->size];

    // possibly unsafe!
    if ( mat->data != 0 ) delete[] mat->data;
    mat->data = dest;
    mat->columns = obs;
    mat->size = inherited::size;

    memcpy(dest, inherited::data + offset * inherited::rows, sizeof(double) * obs);
    for (int i = 1; i < n_cpus; i++) {
      MPI_Send(inherited::data + i * offset * inherited::rows, inherited::size, MPI_DOUBLE, i, 
	       1, MPI_COMM_WORLD);
      // package and distribute blocks of data
    }
    delete inherited::data;

  };

 };

#endif
