#ifndef FILE_NAMES_CPP_UNIVERSITY_OF_OREGON_NIC
#define FILE_NAMES_CPP_UNIVERSITY_OF_OREGON_NIC

#include "file_names.h"

using namespace std;


char *
mangle_name(char * name, char * new_dir, char * new_suff, char * new_ext) 
{
char * dir = strrchr(name, '/');
    char * ext = strrchr(name, '.');
    char * base_name = name;
    char empty = '\0';
    char * name_dir = &empty;
    char * name_suff = &empty;
    char * name_ext = &empty;
    char * rtn;

    int    len = 0;

    /******************************************************
    if dir == NULL then there is no specified path
    else    name[0] -> dir[0] is the path, including the last '/'
       and  dir[1]           is the start of the base name

    if ext == NULL then there is no specified extension
    else    base_name[0]  -> ext[0] is the base name

    /xxx/yyy/..../nnnnnn.aaa.eeee becomes
    dir       = /xxx/yyy/....'\0'
    base_name = nnnnnn.aaa'\0'
    ext       = eeee

    *******************************************************/

    if (dir != NULL) 
    {
        *dir = '\0';
        base_name = dir + 1;
    }

    if (ext != NULL) 
    {
        *ext = '\0';
        ext++;
    }

    /******************************************************

     find the lengths of the parts of the new name and
     allocate an appropriately sized string then concatenate
     the pieces together

    ******************************************************/

    if (new_dir == NULL) 
    {
        if (name != NULL) 
        {
            len += strlen(name) + 1; // include the final '/'
        }
        name_dir = name;
    } 
    else 
    {
        len += strlen(new_dir) + 1;
        name_dir = new_dir;
    }

    if (new_suff != NULL) 
    {
        len += strlen(new_suff);
        name_suff = new_suff;
    }

    len += strlen(base_name);

    if (new_ext == NULL) 
    {
        if (ext != NULL) 
        {
            len += strlen(ext) + 1; // include the '.'
            name_ext = ext;
        }
    } else 
    {
        len += strlen(new_ext) + 1;
        name_ext = ext;
    }

    rtn = new char[len + 1];
    sprintf(rtn,"%s/%s%s.%s", name_dir, name_suff, base_name, name_ext);

    /******************************************************

     Reconstruct the original name

    *****************************************************/

    if (dir != NULL) 
    {
        *dir = '/';
    }

    if (ext != NULL) 
    {
        *(ext - 1) = '.';
    }

    return rtn;
}

char *
make_name(char * name, char * new_dir, char * new_ext)
{
    int    len = 0;
    char * rtn;
    /******************************************************

     find the lengths of the parts of the name and
     allocate an appropriately sized string then concatenate
     the pieces together

    ******************************************************/

    if (new_dir != NULL) 
    {
        len += strlen(new_dir) + 1;
    }

    len += strlen(name);

    if (new_ext != NULL) 
    {
        len += strlen(new_ext) + 1;
    }

    rtn = new char[len + 1];
    sprintf(rtn,"%s/%s.%s", new_dir, name, new_ext);

    return rtn;
}

bool write_validate(char * file_name ) 
{
    bool rtn = false;

    if (access(file_name, W_OK) == 0) 
    {
        rtn = true;
    } else 
    {
        cout << "\n\nERROR: You do not have write permission for file\n\n\t";
        cout << file_name << "\nIf the file or the data path are\n";
        cout << "incorrect, please fix them in the appropriate form,\n";
        cout << "otherwise, please check with your system administrator.\n\n\n";
    }
    return rtn;
};

bool read_validate(char * file_name) 
{
    bool rtn = false;

    if (access(file_name, R_OK) == 0) 
    {
        rtn = true;
    };

    return rtn;
}

#endif
// FILE_NAMES_CPP_UNIVERSITY_OF_OREGON_NIC
