#ifndef GAUSSIAN_CPP_UNIVERSITY_OF_OREGON_NIC
#define GAUSSIAN_CPP_UNIVERSITY_OF_OREGON_NIC

#include "gaussian.h"

using namespace std;

// Purpose: compute the covariance matrix and its eigenvalues
void
gaussian(nic_matrix* x_, nic_vector* weight, 
		  nic_vector* weight_plus) 
{
    double* whitened_x = x_->data;
    double* w = weight->data;
    double* w_plus = weight_plus->data;
    int n_samples = x_->columns;
    int n_channels = x_->rows;

    double* x = NULL;
    double wTx = 0; 
    double wTx_2 = 0;
    double exp_wTx_2 = 0;

    int i = 0, j = 0;

    for (i = 0; i < n_samples; i++) 
    {
        wTx = 0;
        x = whitened_x + i * n_channels;

        // compute wTx
        for (j = 0; j < n_channels; j++) 
        {
            wTx += w[j] * x[j];
        }

        wTx_2 = wTx * wTx;
        exp_wTx_2 = exp(-wTx_2/2);

        for (j = 0; j < n_channels; j++) 
        {   // E(x g(wTx))
            w_plus[j] +=  ( wTx * exp_wTx_2 * x[j] ) - 
                          ((1 - wTx_2) * exp_wTx_2 * w[j]);
        }

    }
}

#endif
// GAUSSIAN_CPP_UNIVERSITY_OF_OREGON_NIC
