#ifndef HYP_TAN_CPP_UNIVERSITY_OF_OREGON_NIC
#define HYP_TAN_CPP_UNIVERSITY_OF_OREGON_NIC

#include "hyp_tan.h"
using namespace std;

// Purpose: compute the covariance matrix and its eigenvalues
void
hyp_tan(nic_matrix* x, nic_vector* weight, 
		  nic_vector* weight_plus) 
{

    int n_channels = x->rows;
    int n_samples = x->columns;
    int total_samples = x->total_columns;

    double* whitened_x = x->data;
    double* w = weight->data;
    double* w_plus = weight_plus->data;

    int i = 0, j = 0;
    double* x_i = NULL;
    double xTw = 0; 
    double ht = 0;

    // make sure w+ is cleared

    for (i = 0; i < n_samples; i++) 
    {
        xTw = 0;
        x_i = whitened_x + i * n_channels;

        for (j = 0; j < n_channels; j++) 
        {
            xTw += x_i[j] * w[j];
        }

        //    ht = tanh(xTw);
        ht = 1 - ( 2 / ( exp(2*xTw) + 1 ) );

        for (j = 0; j < n_channels; j++) 
        {
            w_plus[j] += x_i[j] * ht - (1-ht*ht) * w[j];
        }
    }


    for (j = 0; j < n_channels; j++) 
    {   // E(x g(wTx))
        w_plus[j] /= total_samples;
    }

}

#endif
// HYP_TAN_CPP_UNIVERSITY_OF_OREGON_NIC
