#ifndef NIC_MATRIX_H_UNIVERSITY_OF_OREGON_NIC
#define NIC_MATRIX_H_UNIVERSITY_OF_OREGON_NIC

#include <cstdlib>
#include <cassert>
#include <iostream>
using namespace std;

class nic_vector;

class nic_matrix 
{
public:
    int rows;
    int columns;
    int size;
    int total_size;
    int total_rows;
    int total_columns;
    int n_cpus;
    int rank;
    int referenceCount;

    double* data;

    nic_matrix(int r = 0, int c = 0, int t_r = 0, int t_c = 0, 
         int rk = 0, int n_c = 1);

    nic_matrix(nic_matrix& m);

    ~nic_matrix();

    static void incrementReferenceCount( nic_matrix* matrix );
    static void freeReference( nic_matrix* matrix );

    void zero_matrix();
    void identity_matrix();
    void random_matrix(double min = 0, double max = 1);
    void constant_matrix(double & c);
    void add_row(nic_vector* data, int i);
    void add_column(nic_vector* data, int i);
    void add_diagonal(nic_vector* data);

    void resize( int r = 0, int c = 0, int t_r = 0, int t_c = 0,
        int rk = 0, int n_c = 0 );

    void swap_matrices(nic_matrix* A);

    double& operator()(int i, int j);

    void operator=(nic_matrix& B);
    friend ostream& operator<<(ostream & out, const nic_matrix& v) 
    {
        int r = v.rows;
        int c = v.columns;
        double* data = v.data;
        double* d = NULL;

        for (int i = 0; i < r; i++) 
        {
            d = data + i;
            for (int j = 0; j < c; j++) 
            {
                out << *d << " ";
                d += r;
            }
            cout << endl;
        }
        return out;
    }

};

#endif
// NIC_MATRIX_H_UNIVERSITY_OF_OREGON_NIC
