#ifndef NIC_VECTOR_H_UNIVERSITY_OF_OREGON_NIC
#define NIC_VECTOR_H_UNIVERSITY_OF_OREGON_NIC

#include <iostream>

class nic_matrix;

class nic_vector 
{
public:

    int n;

    double* data;

    nic_vector();
    nic_vector(int n_);
    nic_vector(nic_vector & v);
    ~nic_vector();

    void swap_vectors(nic_vector* v);
    void zero_vector();
    void constant_vector(double & v);
    void random_vector(double min = 0, double max = 1);
    void orthogonalize(nic_matrix* m);
    void normalize();

    void resize( int size ) { delete[] data; data = new double[ size ]; n = size; }

    double& operator()(int i) { return data[ i ]; }

    void operator= (nic_vector& v);
    bool operator== (nic_vector& v);

    friend std::ostream& operator<<(std::ostream & out, 
        const nic_vector& v) 
    {
        int n = v.n;
        double* data = v.data;

        if (n == 0) 
        {
            out << "[]" << std::endl;
        } 
        else 
        {
            out << "[" << *data++;
            for (int i = 1; i < n; i++) 
            {
                out << ", " << *data++;
            }
            out << "]";
        }
        return out;
    }
};

#endif
// NIC_VECTOR_H_UNIVERSITY_OF_OREGON_NIC
