#ifndef READER_H_UNIVERSITY_OF_OREGON_NIC
#define READER_H_UNIVERSITY_OF_OREGON_NIC

#include <cstdio>
#include <iostream>

class Reader
{
private:
    std::istream& 		m_inStream;
	
public:

    Reader( std::istream& inStream );
    virtual void parse( std::istream& inStream ) = 0;
    virtual void get_value() = 0;

    virtual char get_char(char * value) = 0;
    virtual char * get_str(char * value) = 0;
    virtual int get_int(char * value) = 0;
    virtual double get_double(char * value) = 0;
    virtual char ** get_string_set(char * value, int n) = 0;

	bool readNextInstruction();

protected:
    char          ** phrase;
    char             instruction[257];
    char           * value;
    int              current_phrase;
    int              n_phrases;
};

//-----------------------------------------------------------------------------
template <class R>
class Parser : public R
{
private:

	char* trim( char* buf );
    bool is_instruction();

public:

    Parser( std::istream& inStream );
    virtual void parse( std::istream& inStream );

    char get_char(char * value);
    char * get_str(char * value);
    int get_int(char * value);
 
    double get_double(char * value);
  char ** get_string_set(char * value, int n);
};


#endif
// READER_H_UNIVERSITY_OF_OREGON_NIC
